# Generated by Django 4.1.5 on 2023-04-23 02:02

import uuid

import django.db.models.deletion
from django.db import migrations, models

import formkit_ninja.fields


class Migration(migrations.Migration):

    replaces = [
        ("formkit_ninja", "0001_initial"),
        ("formkit_ninja", "0002_remove_formkitschemanode_children_and_more"),
        ("formkit_ninja", "0003_alter_formcomponents_options_formkitschemanode_group_and_more"),
        ("formkit_ninja", "0004_alter_formkitschemanode_group_nodechildren_and_more"),
        ("formkit_ninja", "0005_delete_schemacondition_and_more"),
        ("formkit_ninja", "0006_formkitschemanode_placeholder"),
        ("formkit_ninja", "0007_alter_formcomponents_options_and_more"),
        ("formkit_ninja", "0008_rename_new_values_formkitschemanode_node_and_more"),
    ]

    dependencies = []

    operations = [
        migrations.CreateModel(
            name="FormComponents",
            fields=[
                ("id", models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name="ID")),
                ("order", models.PositiveIntegerField(db_index=True, editable=False, verbose_name="order")),
            ],
            options={
                "ordering": ("order",),
                "abstract": False,
            },
        ),
        migrations.CreateModel(
            name="FormKitSchemaNode",
            fields=[
                (
                    "node_type",
                    models.CharField(
                        blank=True,
                        choices=[
                            ("$cmp", "Component"),
                            ("text", "Text"),
                            ("condition", "Condition"),
                            ("$formkit", "FormKit"),
                            ("$el", "Element"),
                        ],
                        max_length=256,
                    ),
                ),
                (
                    "description",
                    models.TextField(
                        blank=True, help_text="Decribe the type of data / reason for this component", null=True
                    ),
                ),
                ("id", models.UUIDField(default=uuid.uuid4, primary_key=True, serialize=False)),
                ("label", formkit_ninja.fields.TranslatedField(blank=True, null=True)),
                ("values", models.JSONField(blank=True, null=True)),
            ],
        ),
        migrations.CreateModel(
            name="Membership",
            fields=[
                ("id", models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name="ID")),
                ("order", models.PositiveIntegerField(db_index=True, editable=False, verbose_name="order")),
                (
                    "group",
                    models.ForeignKey(
                        limit_choices_to={"node_type": "$formkit", "node_value": "group"},
                        on_delete=django.db.models.deletion.CASCADE,
                        to="formkit_ninja.formkitschemanode",
                    ),
                ),
                (
                    "member",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="members",
                        to="formkit_ninja.formkitschemanode",
                    ),
                ),
            ],
            options={
                "ordering": ("order",),
                "abstract": False,
            },
        ),
        migrations.CreateModel(
            name="FormKitSchema",
            fields=[
                ("id", models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name="ID")),
                ("name", formkit_ninja.fields.TranslatedField()),
                (
                    "nodes",
                    models.ManyToManyField(
                        through="formkit_ninja.FormComponents", to="formkit_ninja.formkitschemanode"
                    ),
                ),
            ],
        ),
        migrations.AddField(
            model_name="formcomponents",
            name="node",
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to="formkit_ninja.formkitschemanode"),
        ),
        migrations.AddField(
            model_name="formcomponents",
            name="schem",
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to="formkit_ninja.formkitschema"),
        ),
        migrations.AddField(
            model_name="formkitschemanode",
            name="group",
            field=models.ManyToManyField(
                blank=True,
                limit_choices_to={"formkitschemaformkit__formkit": "group"},
                through="formkit_ninja.Membership",
                to="formkit_ninja.formkitschemanode",
            ),
        ),
        migrations.AlterField(
            model_name="membership",
            name="group",
            field=models.ForeignKey(
                limit_choices_to={"values__formkit": "group"},
                on_delete=django.db.models.deletion.CASCADE,
                to="formkit_ninja.formkitschemanode",
            ),
        ),
        migrations.CreateModel(
            name="Option",
            fields=[
                ("id", models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name="ID")),
                ("order", models.PositiveIntegerField(db_index=True, editable=False, verbose_name="order")),
                ("value", models.CharField(max_length=1024)),
                ("label", formkit_ninja.fields.TranslatedField(blank=True, null=True)),
                (
                    "field",
                    models.ForeignKey(
                        limit_choices_to={"values__formkit": "group"},
                        on_delete=django.db.models.deletion.CASCADE,
                        to="formkit_ninja.formkitschemanode",
                    ),
                ),
            ],
            options={
                "ordering": ("order",),
                "abstract": False,
            },
        ),
        migrations.AlterField(
            model_name="formkitschemanode",
            name="group",
            field=models.ManyToManyField(
                blank=True, through="formkit_ninja.Membership", to="formkit_ninja.formkitschemanode"
            ),
        ),
        migrations.CreateModel(
            name="NodeChildren",
            fields=[
                ("id", models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name="ID")),
                ("order", models.PositiveIntegerField(db_index=True, editable=False, verbose_name="order")),
                (
                    "child",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="parent",
                        to="formkit_ninja.formkitschemanode",
                    ),
                ),
                (
                    "parent",
                    models.ForeignKey(
                        limit_choices_to={"node_type": "$el"},
                        on_delete=django.db.models.deletion.CASCADE,
                        to="formkit_ninja.formkitschemanode",
                    ),
                ),
            ],
            options={
                "ordering": ("order",),
                "abstract": False,
            },
        ),
        migrations.AddField(
            model_name="formkitschemanode",
            name="children",
            field=models.ManyToManyField(
                blank=True, through="formkit_ninja.NodeChildren", to="formkit_ninja.formkitschemanode"
            ),
        ),
        migrations.AlterField(
            model_name="formkitschemanode",
            name="node_type",
            field=models.CharField(
                blank=True,
                choices=[
                    ("$cmp", "Component"),
                    ("text", "Text"),
                    ("condition", "Condition"),
                    ("$formkit", "FormKit"),
                    ("$el", "Element"),
                    ("raw", "Raw JSON"),
                ],
                max_length=256,
            ),
        ),
        migrations.AddField(
            model_name="formkitschemanode",
            name="placeholder",
            field=formkit_ninja.fields.TranslatedField(blank=True, null=True),
        ),
        migrations.AlterModelOptions(
            name="formcomponents",
            options={"ordering": ("schem", "order")},
        ),
        migrations.AddField(
            model_name="formkitschemanode",
            name="node",
            field=models.JSONField(blank=True, null=True),
        ),
        migrations.RemoveField(
            model_name="formkitschemanode",
            name="values",
        ),
        migrations.AddField(
            model_name="formkitschemanode",
            name="help",
            field=formkit_ninja.fields.TranslatedField(blank=True, null=True),
        ),
    ]
